//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ImageSelectionPart0.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bitnShowImageClick(TObject *Sender)
{
  Form1->Canvas->Draw(0,0, Image1->Picture->Graphic);
}
//---------------------------------------------------------------------------
void JpgToBmp(TImage *image)
{
  Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0, 0, image->Picture->Graphic);
  image->Picture->Assign(bmp);

  delete bmp;
}

int prevX, prevY;
bool drawing=false;
TRect bndRect;

void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  prevX = X;  prevY = Y;
  drawing = true;
  bndRect.left   = X-5;
  bndRect.top    = Y-5;
  bndRect.right  = X+5;
  bndRect.bottom = Y+5;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  int dr = 3, ds = 10;

  if ( drawing )
    {
      if ( X-dr<=bndRect.left )
        { bndRect.left = X-ds;
        }
      else if ( X+dr>=bndRect.right )
        bndRect.right = X+ds;

      if ( Y-dr<=bndRect.top )
        { bndRect.top = Y-ds;
        }
      else if ( Y+dr>=bndRect.bottom )
        bndRect.bottom = Y+ds;

      Form1->Canvas->CopyRect(bndRect,
                              Image1->Picture->Bitmap->Canvas,
                              bndRect );

      Canvas->Brush->Style = bsClear;
      Canvas->Ellipse(prevX, prevY, X, Y);
      Canvas->Brush->Style = bsSolid;

      Canvas->Pen->Color = clRed;

      float cx, cy, a, b, sqrt2 = sqrt(2);
      a = (X - prevX) / 2.;
      b = (Y - prevY) / 2.;
      cx = prevX + a;
      cy = prevY + b;
      //===== WUk I
      Canvas->Rectangle(prevX-dr, prevY+b-dr, prevX+dr, prevY+b+dr); // left
      Canvas->Rectangle(X-dr, prevY+b-dr, X+dr, prevY+b+dr); // right
      Canvas->Rectangle(prevX+a-dr, prevY-dr, prevX+a+dr, prevY+dr); // top
      Canvas->Rectangle(prevX+a-dr, Y-dr, prevX+a+dr, Y+dr); // bottom
      Canvas->Rectangle(prevX+a-dr, Y-dr, prevX+a+dr, Y+dr);
      //===== צV I
      a /= sqrt2;
      b /= sqrt2;
      Canvas->Rectangle(cx-a-dr,cy-b-dr,cx-a+dr,cy-b+dr);
      Canvas->Rectangle(cx-a-dr,cy+b-dr,cx-a+dr,cy+b+dr);
      Canvas->Rectangle(cx+a-dr,cy-b-dr,cx+a+dr,cy-b+dr);
      Canvas->Rectangle(cx+a-dr,cy+b-dr,cx+a+dr,cy+b+dr);
      /*===== I
      Canvas->Ellipse(prevX-dr,prevY-dr,prevX+dr,prevY+dr);
      Canvas->Ellipse(X-dr,prevY-dr,X+dr,prevY+dr);
      Canvas->Ellipse(prevX-dr,Y-dr,prevX+dr,Y+dr);
      Canvas->Ellipse(X-dr,Y-dr,X+dr,Y+dr);
      //*/
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  drawing = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Form1->DoubleBuffered = true;
  Form1->ClientWidth = 2* Image1->Width + 3;
  JpgToBmp(Image1);
  Image1->Left = Image1->Width + 2;
  Image1->Top  = 0;
  bitnShowImage->Top  = Image1->Height + 10;
  bitnShowImage->Left = (Image1->Width-bitnShowImage->Width) / 2;
}
//---------------------------------------------------------------------------

